#ifndef CQUICKSORT
#define CQUICKSORT

#include "CTempSwitch.h"


template <class item>
void place(item a[], int u, int v, int& k)
{
  int i=u+1;
  int j=v;
  while (i<=j)
  {
    for (; i<=v && a[i]<=a[u]; i++ );
    for (; u+1<=j && a[u]<=a[j]; j-- );
    if (i<j)
    {
      tempswitch<item> (a[i], a[j]);
      i++; j--;
    }
  }
  tempswitch<item> (a[u], a[i-1]);
  k=i-1;
};


template <class item>
void quicksort(item a[], int ah, int fh)
{
  if (ah < fh)
  {
    int k=(ah+fh)/2;
    place(a, ah, fh, k);
    quicksort(a, ah, k-1);
    quicksort(a, k+1, fh);
  }
}


template <class item>
void sort(item array[], int array_size)
{
  quicksort(array, 0, array_size-1);
};

#endif
